# Implementation of PAC-Bayesian kl-bound and PAC-Bayesian Catoni-bound algorithm in PyTorch 1.2.0

we build our project based on the implementation of the paper R. Amit, R. Meir, “Meta-Learning by Adjusting Priors Based on Extended PAC-Bayes Theory”,  ICML 2018.

## Prerequisites

- Python 3.7
- [PyTorch 1.2.0 with CUDA]
- NumPy and Matplotlib


## Data

The data sets are downloaded automatically. Specify the main data path in the file 'Data_Path.py'

## Reproducing experiments in the paper:

python PriorMetaLearning/run_MPB_ShuffledPixels.py   - Run our kl-bound based algorithm or Catoni-bound based algorithm. When choose the hyperparameter 'complexity-type' as 'PAC_Bayes_Abel_kl', it runs kl-bound based algorithm; when choose the hyperparameter 'complexity-type' as 'PAC_Bayes_Abel_Catoni', it runs Catoni-bound based algorithm. See more introductions of different hyperparameters in the file 'main_Meta_Bayes.py'

python PriorMetaLearning/run_MPB_ShuffledPixels_TasksN_100_pixels_kl.py - Run our kl-bound based algorithm across a range of the number $n$ of training tasks in the 100-pixel-shuffled environment

python PriorMetaLearning/run_MPB_ShuffledPixels_SampleM_100_pixels_kl.py -Run our kl-bound based algorithm across a range of the sample size $m$ per task in the 100-pixel-shuffled environment

