import os
import argparse

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Run meta-training with different number of tasks.')
    parser.add_argument("--algorithm", type=str, default='SVGD')
    parser.add_argument("--exp_id", type=str, required=True)
    args = parser.parse_args()

    n_train_tasks_list = [10, 20, 40, 80]
    plot = True


    cmd_full = ""
    if args.algorithm == 'SVGD':
        script = "meta_regression_SVGD.py"
    elif args.algorithm == "MLAP":
        script = "meta_regression_MLAP.py"
    else:
        raise Exception("Unexpected argument passed as algorithm")

    for n_train_tasks in n_train_tasks_list:
        output_file = "test/{}_mem_{}".format(args.exp_id, n_train_tasks)

        cmd_run = "mprof run -o {}.dat pacoh/experiments/resource_profiling/{} --num_train_tasks {}".format(output_file, script, n_train_tasks)

        if plot:
            cmd_run += " && mprof plot -o {}.png {}.dat".format(output_file, output_file)
        cmd_full = cmd_full.strip()
        if cmd_full:
            # not empty
            cmd_full += " && {}".format(cmd_run)
        else:
            cmd_full = cmd_run

    os.system(cmd_full)