import os
import pandas as pd
import numpy as np
import argparse

from config import DATA_DIR
HPARAM_EXP_DIR = '/home/jonasrothfuss/Dropbox/Eigene_Dateien/ETH/02_Projects/01_Meta-learning_GP-priors/gp-priors/data/MR_MAML_results'

def main(args):
    DATASET = args.dataset  # put dataset name here to filer results

    csv_files = [path for path in os.listdir(HPARAM_EXP_DIR) if '.csv' in path and args.prefix in path]

    for csv_name in csv_files:
        if DATASET in csv_name:

            CSV_PATH = os.path.join(HPARAM_EXP_DIR, csv_name)

            # 1) load df
            df = pd.read_csv(CSV_PATH)

            # 2) aggregate over seeds


            hyperparams = list(
                set(df.columns) - {'Unnamed: 0', 'timesteps_total', 'random_seed', 'loss', 'rmse_1_steps',
                                   'rmse_5_steps', 'rmse_10_steps'})

            df_aggregated = df.groupby(hyperparams).aggregate(
                {'rmse_1_steps': [np.mean, np.std],
                 'rmse_5_steps': [np.mean, np.std]}).round(3)


            print(csv_name)
            print(df_aggregated.to_string(), '\n')
            #print(df_aggregated.reset_index(drop=True).to_string(), '\n')

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Run meta mll hyper-parameter search.')
    parser.add_argument("--dataset", type=str, default='physi')
    parser.add_argument("--prefix", type=str, default='')
    args = parser.parse_args()
    main(args)