## GOHP-NN: Gibbs Optimal Hyper-Posterior Algorithm for Meta LEarning
This repository provides source code for the *GOHP-NN* method, introduced in the paper [Fast-Rate PAC-Bayesian Generalization Bounds for Meta-Learning] (by Jiechao Guan, Zhiwu Lu) published in International Conference on Machine Learning (ICML) 2022. 

## Basic Requirements
Python 3.7.3
PyTorch 1.3.1

## Installation
Install the required packages using the following command:
```
pip install -r requirements.txt
``` 
## Download Datasets
Different datasets are included in the Dropbox folder "https://www.dropbox.com/sh/2n7ohp8nfoahggt/AAA7DLmSOF19LHJAtsipEL2Ha?dl=0", which is shared by Jonas Rothfuss. Download the datasets, and place them in the ./data/ folder.


## Usage
To reproduce the regression results over cauchy datasets
```python run_cauchy.py
```
To reproduce the regression results over swissfel datasets
```python run_swissfel.py
```

## Reference
We build our repository based on the source code provided by the *PACOH-NN* method, introduced in the paper [*PACOH: Bayes-Optimal Meta-Learning with PAC-Guarantees*](https://arxiv.org/abs/2002.05551).
